#
# Conditional build:
%bcond_with	tests		# test suite

%define		kdeframever	6.14
%define		qt_ver		6.7.0
%define		kf_ver		%{version}
%define		kfname		kconfig

Summary:	Backend for storing application configuration
Summary(pl.UTF-8):	Backend do przechowywania konfiguracji aplikacji
Name:		kf6-%{kfname}
Version:	6.14.0
Release:	2
License:	LGPL v2.1+
Group:		X11/Libraries
Source0:	https://download.kde.org/stable/frameworks/%{kdeframever}/%{kfname}-%{version}.tar.xz
# Source0-md5:	84762f48c328e4e34fc4b0765829e9c7
URL:		https://kde.org/
BuildRequires:	Qt6Core-devel >= %{qt_ver}
BuildRequires:	Qt6DBus-devel >= %{qt_ver}
BuildRequires:	Qt6Gui-devel >= %{qt_ver}
BuildRequires:	Qt6Qml-devel >= %{qt_ver}
BuildRequires:	Qt6Quick-devel >= %{qt_ver}
%{?with_tests:BuildRequires:	Qt6Test-devel >= %{qt_ver}}
BuildRequires:	Qt6Xml-devel >= %{qt_ver}
BuildRequires:	cmake >= 3.16
BuildRequires:	kf6-extra-cmake-modules >= %{kf_ver}
BuildRequires:	ninja
BuildRequires:	qt6-linguist >= %{qt_ver}
BuildRequires:	rpmbuild(macros) >= 1.736
BuildRequires:	tar >= 1:1.22
BuildRequires:	xz
Requires:	Qt6DBus >= %{qt_ver}
Requires:	Qt6Gui >= %{qt_ver}
Requires:	Qt6Qml >= %{qt_ver}
Requires:	Qt6Quick >= %{qt_ver}
Requires:	Qt6Xml >= %{qt_ver}
Requires:	kf6-dirs
#Obsoletes:	kf5-kconfig < 6
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
KConfig provides an advanced configuration system. It is made of two
parts: KConfigCore and KConfigGui.

KConfigCore provides access to the configuration files themselves. It
features:
- Code generation: describe your configuration in an XML file, and use
  kconfig_compiler to generate classes that read and write
  configuration entries.
- Cascading configuration files (global settings overridden by local
  settings).
- Optional shell expansion support
- The ability to lock down configuration options

KConfigGui provides a way to hook widgets to the configuration so that
they are automatically initialized from the configuration and
automatically propagate their changes to their respective
configuration files.

%description -l pl.UTF-8
KConfig udostępnia zaawansowany system konfiguracji. Składa się z
dwóch części: KConfigCore oraz KConfigGui.

KConfigCore zapewnia dostęp do samych plików konfiguracyjnych.
Funkcjonalność:
- generowanie kodu: wystarczy opisać konfigurację w pliku XML i użyć
  programu kconfig_compiler, aby wygenerować klasy czytające i
  zapisujące wpisy konfiguracji
- kaskadowe pliki konfiguracyjne (globalne ustawienia nadpisywane
  przez lokalne ustawienia)
- opcjonalna obsługa dopełniania poleceń
- możliwość zablokowania opcji konfiguracyjnych

KConfigGui zapewnia sposób podpięcia widżetów do konfiguracji tak, aby
były automatycznie inicjowane z konfiguracji i automatycznie
propagowały zmiany do odpowiednich plików konfiguracyjnych.

%package devel
Summary:	Header files for %{kfname} development
Summary(pl.UTF-8):	Pliki nagłówkowe dla programistów używających %{kfname}
Group:		X11/Development/Libraries
Requires:	%{name} = %{version}-%{release}
Requires:	Qt6DBus-devel >= %{qtver}
Requires:	Qt6Qml-devel >= %{qtver}
Requires:	Qt6Xml-devel >= %{qtver}
Requires:	cmake >= 3.16
#Obsoletes:	kf5-kconfig-devel < 6

%description devel
Header files for %{kfname} development.

%description devel -l pl.UTF-8
Pliki nagłówkowe dla programistów używających %{kfname}.

%prep
%setup -q -n %{kfname}-%{version}

%build
%cmake -B build \
	-G Ninja \
	%{!?with_tests:-DBUILD_TESTING=OFF} \
	-DKDE_INSTALL_USE_QT_SYS_PATHS=ON

%ninja_build -C build

%if %{with tests}
%ninja_build -C build test
%endif

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT%{_datadir}/kconf_update

%ninja_install -C build

%find_lang %{kfname}5_qt --with-qm --all-name --with-kde

%clean
rm -rf $RPM_BUILD_ROOT

%post	-p /sbin/ldconfig
%postun	-p /sbin/ldconfig

%files -f %{kfname}5_qt.lang
%defattr(644,root,root,755)
%doc DESIGN README.md TODO
%attr(755,root,root) %{_bindir}/kreadconfig6
%attr(755,root,root) %{_bindir}/kwriteconfig6
%attr(755,root,root) %{_libexecdir}/kf6/kconf_update
%attr(755,root,root) %{_libexecdir}/kf6/kconfig_compiler_kf6
%attr(755,root,root) %{_libdir}/libKF6ConfigCore.so.*.*
%ghost %{_libdir}/libKF6ConfigCore.so.6
%attr(755,root,root) %{_libdir}/libKF6ConfigGui.so.*.*
%ghost %{_libdir}/libKF6ConfigGui.so.6
%attr(755,root,root) %{_libdir}/libKF6ConfigQml.so.*.*
%ghost %{_libdir}/libKF6ConfigQml.so.6
%dir %{_libdir}/qt6/qml/org/kde/config
%attr(755,root,root) %{_libdir}/qt6/qml/org/kde/config/libKF6ConfigQmlplugin.so
%{_libdir}/qt6/qml/org/kde/config/KF6ConfigQml.qmltypes
%{_libdir}/qt6/qml/org/kde/config/kde-qmlmodule.version
%{_libdir}/qt6/qml/org/kde/config/qmldir
%dir %{_datadir}/kconf_update
%{_datadir}/qlogging-categories6/kconfig.categories
%{_datadir}/qlogging-categories6/kconfig.renamecategories

%files devel
%defattr(644,root,root,755)
%{_libdir}/libKF6ConfigCore.so
%{_libdir}/libKF6ConfigGui.so
%{_libdir}/libKF6ConfigQml.so
%{_includedir}/KF6/KConfig
%{_includedir}/KF6/KConfigCore
%{_includedir}/KF6/KConfigGui
%{_includedir}/KF6/KConfigQml
%{_libdir}/cmake/KF6Config
%changelog
* Sat May 31 2025 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/kf6-kconfig.git;a=log;h=master

* Sat May 31 2025 Jakub Bogusz <qboosh@pld-linux.org> 388502c
- release 2

* Sat May 31 2025 Jakub Bogusz <qboosh@pld-linux.org> 587fc20
- updated more dependencies

* Sat May 31 2025 Jakub Bogusz <qboosh@pld-linux.org> acf669f
- pl

* Sat May 31 2025 Jakub Bogusz <qboosh@pld-linux.org> 9983744
- files cleanup, added missing Qml dependency

* Sat May 10 2025 Witold Filipczyk <witekfl@poczta.onet.pl> 86547ad
- updated to 6.14.0

* Sat Apr 12 2025 Witold Filipczyk <witekfl@poczta.onet.pl> 2aa4142
- updated to 6.13.0

* Sun Mar 16 2025 Witold Filipczyk <witekfl@poczta.onet.pl> 6a631ea
- updated to 6.12.0

* Sat Feb 15 2025 Witold Filipczyk <witekfl@poczta.onet.pl> 5ce8263
- updated to 6.11.0

* Fri Jan 10 2025 Witold Filipczyk <witekfl@poczta.onet.pl> 9d3819f
- updated to 6.10.0

* Fri Dec 13 2024 Witold Filipczyk <witekfl@poczta.onet.pl> 4ababb4
- updated to 6.9.0

* Fri Nov 08 2024 Witold Filipczyk <witekfl@poczta.onet.pl> 7b1f583
- updated to 6.8.0

* Fri Oct 11 2024 Witold Filipczyk <witekfl@poczta.onet.pl> 4dc3373
- updated to 6.7.0

* Sat Sep 14 2024 Witold Filipczyk <witekfl@poczta.onet.pl> e014344
- updated to 6.6.0

* Sun Aug 11 2024 Witold Filipczyk <witekfl@poczta.onet.pl> b260a81
- updated to 6.5.0

* Wed Aug 07 2024 Krzysztof Mrozowicz <mrozowik@pld-linux.org> 7b73233
- relup

* Sat Jul 13 2024 Witold Filipczyk <witekfl@poczta.onet.pl> 419f694
- updated to 6.4.0

* Sat Jun 08 2024 Witold Filipczyk <witekfl@poczta.onet.pl> 5231426
- updated to 6.3.0

* Fri May 24 2024 Witold Filipczyk <witekfl@poczta.onet.pl> 5c38fee
- Obsoletes kf5

* Sat May 11 2024 Witold Filipczyk <witekfl@poczta.onet.pl> 117bd4f
- updated to 6.2.0

* Sun Apr 14 2024 Witold Filipczyk <witekfl@poczta.onet.pl> be45571
- updated to 6.1.0

